﻿<template>
  <form class="conteiner" @submit.prevent="checkForm">
    <div class="registration">Регистрация</div>
    <div class="conteiner-account">
      <p>Уже есть аккаунт?</p>
      <a href="#">Войти</a>
    </div>
    <div class="conteiner-input-name">
      <p>Имя</p>
      <input
        type="text"
        class="input-name"
        placeholder="Введите Ваше имя"
        v-model.trim="name"
        :class="$v.name.$error ? 'invalid' :''"
      />
      <span class="incorrect-value" v-if="$v.name.$dirty && !$v.name.required"
        >Обязательное поле ввода</span
      >
      <span class="incorrect-value" v-if="$v.name.$dirty && !$v.name.alpha"
        >Введено не корректное значение</span
      >
    </div>
    <div class="conteiner-input-email">
      <p>Email</p>
      <input
        type="email"
        class="input-email"
        name="Введите ваш email"
        placeholder="Введите ваш email"
        v-model.trim="email"
        :class="$v.email.$error ? 'invalid' :''"
      />
      <span class="incorrect-value" v-if="$v.name.$dirty&&!$v.email.required">
        Обязательное поле ввода</span>
      <span class="incorrect-value" v-if="$v.name.$dirty &&!$v.email.email"
        >Введено не корректное значение</span
      >
    </div>
    <div class="conteiner-input-number">
      <p>Номер телефона</p>
      <input
        type="text"
        class="input-number"
        placeholder="Введите номер телефона"
        v-model.trim="number"
        :class="$v.number.$error ? 'invalid' :''"
      />
      <span class="incorrect-value" v-if="$v.name.$dirty &&!$v.number.required"
        >Обязательное поле ввода</span>
      
      <span
        class="incorrect-value"
        v-if="$v.name.$dirty &&!$v.number.validNumber"
        >Введено не корректное значение</span>
   
    </div>
    <div class="conteiner-dropdown-language">
      <p>Язык</p>
       <select class="dropdown-language" v-model="select"> 
         <option value="" 
                 v-for="(language, index) in languages"        
                 :key="index">{{language.label}}</option>
        </select>      
        </div>
    <div class="conteiner-conditions">
      <input 
      class="condition-checkbox"
      type="checkbox" 
      name="" id="" 
      v-model="condition" :class="$v.condition.$error ? 'invalid' : ''"/> 
      <p class="condition-text" 
         :class="$v.condition.$error ? 'invalid-text' : ''" >Принимаю</p>
      <a class="condition-link" 
         :class="$v.condition.$error ? 'invalid-text' : ''" href="#">условия</a>
      <p class="condition-text" 
         :class="$v.condition.$error ? 'invalid-text' : ''" >использования</p>
    </div>
    <button
      class="btn-regisration"
      type="submit"
      :class="!disabledBtnFinish ? 'active' :''"
    >
      Зарегистрироваться
    </button>
  </form>
</template>

<script>
    //Подключение vuelidate и обявление переменных, для валидирования вводимых данных
import { validationMixin } from 'vuelidate'
import { required, email, minLength, helpers} from 'vuelidate/lib/validators';
const alpha = helpers.regex('alpha', /^[а-яА-ЯёЁa-zA-Z\s.-]+$/ )
const validNumber = helpers.regex('validNumber', /^[0-9.-.+.()]+$/ )

export default {
    mixins: [validationMixin],
    data(){
      
        return { 
                     email:'',		      	         
                     name:'',
                     number:'',
                     select:'',
                     condition:false,
                     languages:[
                                {label: 'Русский', value: 'Russian'} ,
                                {label: 'Английский', value:'English'},
                                {label:'Китайский', value:'Chinise'},
                                {label: 'Испанский', value:'Spanish'}
                                ]
                }
            },
	computed:{
    // Функция отключения диактивации конопки, при вводе всех данных корректно
		disabledBtnFinish() {
       return this.$v.email.$invalid ||
              this.$v.name.$invalid ||
              this.$v.number.$invalid ||
              this.$v.condition.$invalid
		}

	},
  validations: {
                 email: {required, email},
		name: {required, alpha},
		number:{required, minLength: minLength(11), validNumber},
    condition:{
      mustBeTrue(value) {
        return value
      }
    }     
           

    },
    methods: {
      //Функция проверки успешной отправки формы
        checkForm() {
            this.$v.$touch()
            if (!this.$v.$error) {
                console.log('Валидация прошла успешно');
            }

        }
    }
}
</script>

<style>


body {
  margin: 0 auto;
}

@media screen and (min-width: 460px) {
  .conteiner {
    width: 30%;
  }
}

.conteiner {
  /* border: 1px solid red; */
  /* max-width: 460px; */
  margin-top: 100px;
  margin-left: 100px;
  width: 460px;
  height: 789px;
  background: #ffffff;
  box-shadow: 0px 12px 24px rgba(44, 39, 56, 0.02),
    0px 32px 64px rgba(44, 39, 56, 0.04);
  border-radius: 24px;
}

.registration {
  padding-left: 30px;
  padding-top: 44.5px;
  height: 44.45px;
  width: 210px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: bold;
  font-size: 34px;
  line-height: 44px;
  color: #2c2738;
  font-weight: 700;
}

.conteiner-account {
  display: inline-flex;
  margin-left: 30px;
}

.conteiner-account p {
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 22px;
  font-weight: 400;
  margin-top: 8px;
}

.conteiner-account a {
  margin-top: 8px;
  margin-left: 6px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 22px;
  color: #0880ae;
  text-decoration: none;
  font-weight: 400;
}

.conteiner-input-name p {
  margin-top: 24px;
  margin-left: 30px;
  margin-bottom: 8px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.input-name {
  margin-top: 3px;
  margin-left: 30px;
  width: 400px;
  height: 52px;
  background: #ffffff;
  border: 1px solid #dbe2ea;
  box-sizing: border-box;
  box-shadow: 0px 4px 8px rgba(44, 39, 56, 0.04);
  border-radius: 6px;
  outline: none;
}

::placeholder {
  padding-left: 16px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 400;
  font-size: 16px;
  line-height: 21px;
  color: #7c9cbf;
}

.conteiner-input-email p {
  margin-top: 20px;
  margin-left: 30px;
  margin-bottom: 8px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.input-email {
  margin-top: 3px;
  margin-left: 30px;
  width: 400px;
  height: 52px;
  background: #ffffff;
  border: 1px solid #dbe2ea;
  box-sizing: border-box;
  box-shadow: 0px 4px 8px rgba(44, 39, 56, 0.04);
  border-radius: 6px;
  outline: none;
}

.conteiner-input-number p {
  margin-top: 30px;
  margin-left: 30px;
  margin-bottom: 8px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.input-number {
  margin-top: 3px;
  margin-left: 30px;
  width: 400px;
  height: 52px;
  background: #ffffff;
  border: 1px solid #dbe2ea;
  box-sizing: border-box;
  box-shadow: 0px 4px 8px rgba(44, 39, 56, 0.04);
  border-radius: 6px;
  outline: none;
}

.conteiner-dropdown-language p {
  margin-top: 24px;
  margin-left: 30px;
  margin-bottom: 8px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.dropdown-language {
  margin-left: 30px;
  display: inline-flex;
  width: 400px;
  height: 52px;
  background: #ffffff;
  border: 1px solid #dbe2ea;
  box-sizing: border-box;
  box-shadow: 0px 4px 8px rgba(44, 39, 56, 0.04);
  border-radius: 6px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #7C9CBF;
  padding-left: 16px;
}

.language {
  margin-left: 16px;
  margin-top: 8px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #7c9cbf;
}

.dropdown-language button {
  margin-left: 300px;
  margin-top: 15px;
  width: 30px;
  height: 30px;
  outline: none;
  border: none;
  background: white;
  cursor: pointer;
}

.dropdown-menu {
  margin-left: 30px;
  width: 400px;
  height: 200px;
  z-index: 1;
  background: #ffffff;
  border: 1px solid #dbe2ea;
  box-sizing: border-box;
  box-shadow: 0px 4px 8px rgba(44, 39, 56, 0.04),
    0px 20px 20px rgba(44, 39, 56, 0.04);
  border-radius: 6px;
  display: none;
}

.dropdown-menu h3 {
  margin-left: 15px;
  margin-top: 23px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 400;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.dropdown-menu h3:hover {
  background: #ebf4f8;
  width: 383px;
  height: 32px;
  margin: 0px;
  padding-left: 15px;
  padding-top: 12px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 400;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
  cursor: pointer;
}

.conteiner-conditions {
  display: inline-flex;
  margin-left: 30px;
  margin-top: 31px;
}

.condition-text {
  margin-left: 8px;
  margin-top: 1px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  color: #756f86;
}

.condition-link {  
  margin-left: 4px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 22px;
  color: #0880ae;
  text-decoration: none;
  font-weight: 500;
}

.condition-checkbox {
  margin-top: 0px;
  width: 28px;
  height: 28px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 16px;
  line-height: 22px;
  color: #0880ae;
  text-decoration: none;
  font-weight: 400;
}

.btn-regisration {
  margin-top: 25.8px;
  margin-left: 30px;
  height: 56.57362365722656px;
  width: 400px;
  background: #dbe2ea;
  box-shadow: 0px 2px 4px rgba(44, 39, 56, 0.08),
    0px 4px 8px rgba(44, 39, 56, 0.08);
  border-radius: 6px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  text-align: center;
  color: #b1b5bf;
  border: none;
}

.active {
  background: #0880ae;
  box-shadow: 0px 2px 4px rgba(44, 39, 56, 0.08),
    0px 4px 8px rgba(44, 39, 56, 0.08);
  border-radius: 6px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: 500;
  font-size: 16px;
  line-height: 21px;
  text-align: center;
  color: #ebf4f8;
}

.show {
  display: block;
}
.invalid {
  border: 1px solid red;  
}
.invalid-text {
  color:  red;  
}
.incorrect-value {
  margin-left: 31px;
  font-family: IBM Plex Sans;
  font-style: normal;
  font-weight: normal;
  font-size: 14px;
  line-height: 18px;
  color: #ff7171;
}
</style>
